/* File:        org.molgenis.omx/model/MolgenisPermission.java
 * Copyright:   GBIC 2000-2,013, all rights reserved
 * Date:        August 21, 2013
 * Template:	JpaMapperGen.java.ftl
 * generator:   org.molgenis.generators.db.JpaMapperGen 4.0.0-testing
 *
 * Jpa Entity Mapper, helper to add, delete and update entities
 * 
 * THIS FILE HAS BEEN GENERATED, PLEASE DO NOT EDIT!
 */

package org.molgenis.omx.auth.db;

@edu.umd.cs.findbugs.annotations.SuppressWarnings(value = "DLS_DEAD_LOCAL_STORE", justification = "Too much template code required to prevent warnings")
public class MolgenisPermissionJpaMapper extends org.molgenis.framework.db.jpa.AbstractJpaMapper<org.molgenis.omx.auth.MolgenisPermission>
{
	private final static org.apache.log4j.Logger log = org.apache.log4j.Logger.getLogger(MolgenisPermissionJpaMapper.class);

	public MolgenisPermissionJpaMapper(org.molgenis.framework.db.Database db) 
	{
		super(db);
	}
	
	@Override
	public String createFindSqlInclRules(org.molgenis.framework.db.QueryRule[] rules) throws org.molgenis.framework.db.DatabaseException
	{
		return "SELECT MolgenisPermission.id"
			+", MolgenisPermission.Identifier"
			+", MolgenisPermission.Name"
			+", MolgenisPermission.role_"
			+", MolgenisPermission.entity"
			+", MolgenisPermission.permission"
			//parent is SimpleTree(name='role_')
			+", xref_role_.Name AS role__Name"
			//parent is SimpleTree(name='entity')
			+", xref_entity.className AS entity_ClassName"
			+" FROM MolgenisPermission "

			
			//label for role_=Name
//path==role_. type==xref.
//path==role__Name. type==string.
//in if path.value.type != "xref" && !pathlist?seq_contains(path.getParent().name)
		   	+" LEFT JOIN MolgenisRole AS xref_role_ " 
			+" ON xref_role_.id = MolgenisPermission.role_"
			
			//label for entity=className
//path==entity. type==xref.
//path==entity_ClassName. type==string.
//in if path.value.type != "xref" && !pathlist?seq_contains(path.getParent().name)
		   	+" LEFT JOIN MolgenisEntity AS xref_entity " 
			+" ON xref_entity.id = MolgenisPermission.entity"
;
	}	

	/** This method first saves the objects that are being refered to by entity, 
	then the entity itself and 
	finally the objects that refer to this object*/
    public void create(org.molgenis.omx.auth.MolgenisPermission entity) throws org.molgenis.framework.db.DatabaseException {
        try {


			//check if the object refered by 'role_' is known in the databse
			if(entity.getRole() != null)
			{
				//if object has been added as xref, but not yet stored (has no id) -> add the refered object
				if(entity.getRole().getIdValue() == null)
					new org.molgenis.omx.auth.db.MolgenisRoleJpaMapper(getDatabase()).create(entity.getRole());
				//if object has id (so is stored) but not in this em -> retrieve proper reference reference
				else if (!getEntityManager().contains(entity.getRole()) && entity.getRole().getIdValue() != null)
					entity.setRole(getEntityManager().getReference(org.molgenis.omx.auth.MolgenisRole.class, entity.getRole().getIdValue()));
			} else { //object is reference by xref	
				if(entity.getRole_Id() != null) {
					entity.setRole((org.molgenis.omx.auth.MolgenisRole)getEntityManager().find(org.molgenis.omx.auth.MolgenisRole.class, entity.getRole_Id()));
				}
			}
			//check if the object refered by 'entity' is known in the databse
			if(entity.getEntity() != null)
			{
				//if object has been added as xref, but not yet stored (has no id) -> add the refered object
				if(entity.getEntity().getIdValue() == null)
					new org.molgenis.omx.core.db.MolgenisEntityJpaMapper(getDatabase()).create(entity.getEntity());
				//if object has id (so is stored) but not in this em -> retrieve proper reference reference
				else if (!getEntityManager().contains(entity.getEntity()) && entity.getEntity().getIdValue() != null)
					entity.setEntity(getEntityManager().getReference(org.molgenis.omx.core.MolgenisEntity.class, entity.getEntity().getIdValue()));
			} else { //object is reference by xref	
				if(entity.getEntity_Id() != null) {
					entity.setEntity((org.molgenis.omx.core.MolgenisEntity)getEntityManager().find(org.molgenis.omx.core.MolgenisEntity.class, entity.getEntity_Id()));
				}
			}

			//prevents uncontrolled recursion call of create (stack overflow)
          
          if(entity.getIdValue() != null) {
            entity = getEntityManager().merge(entity);            
          } else {
            getEntityManager().persist(entity);
          }
//inverse association relation

        } catch (Exception ex) {
            try {
				getEntityManager().getTransaction().rollback();
            } catch (Exception re) {
                throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: "+re.getMessage());
            }
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
    }

	public void destroy(org.molgenis.omx.auth.MolgenisPermission molgenisPermission) throws org.molgenis.framework.db.DatabaseException {
		try {
			try {
				molgenisPermission = getEntityManager().getReference(org.molgenis.omx.auth.MolgenisPermission.class, molgenisPermission.getIdValue());
			} catch (javax.persistence.EntityNotFoundException enfe) {
				throw new org.molgenis.framework.db.DatabaseException("The molgenisPermission with id " + molgenisPermission.getIdField().toString() + " no longer exists: " + enfe.getMessage());
			}

			getEntityManager().remove(molgenisPermission);
		} catch (Exception ex) {
			try {
				getEntityManager().getTransaction().rollback();
			} catch (Exception re) {
				throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: "+re.getMessage());
			}
			throw new org.molgenis.framework.db.DatabaseException(ex);
		} 
	}


	public void edit(org.molgenis.omx.auth.MolgenisPermission molgenisPermission) throws org.molgenis.framework.db.DatabaseException {
		try {





			//5
			org.molgenis.omx.auth.MolgenisRole role_New = molgenisPermission.getRole();

			if (role_New == null) { //object is reference by xref		
                            if(molgenisPermission.getRole_Id() != null) {
                                molgenisPermission.setRole((org.molgenis.omx.auth.MolgenisRole)getEntityManager().find(org.molgenis.omx.auth.MolgenisRole.class, molgenisPermission.getRole_Id()));
                            }
			}


			//1
			org.molgenis.omx.core.MolgenisEntity entityNew = molgenisPermission.getEntity();

			if (entityNew == null) { //object is reference by xref		
                            if(molgenisPermission.getEntity_Id() != null) {
                                molgenisPermission.setEntity((org.molgenis.omx.core.MolgenisEntity)getEntityManager().find(org.molgenis.omx.core.MolgenisEntity.class, molgenisPermission.getEntity_Id()));
                            }
			}

			if(!getEntityManager().contains(molgenisPermission)) {
				molgenisPermission = getEntityManager().merge(molgenisPermission);
			}
			


		} catch (Exception ex) {
			try {
				getEntityManager().getTransaction().rollback();
			} catch (Exception re) {
				throw new org.molgenis.framework.db.DatabaseException("An error occurred attempting to roll back the transaction: " + re.getMessage());
			}
			throw new org.molgenis.framework.db.DatabaseException(ex);
		} 
	}

	@Override
	public int executeAdd(java.util.List<? extends org.molgenis.omx.auth.MolgenisPermission> entities) throws org.molgenis.framework.db.DatabaseException
	{	
		int count = 0;
		
		try 
		{
			for (org.molgenis.omx.auth.MolgenisPermission molgenisPermission : entities) 
			{
				create(molgenisPermission);
				++count;
			}
		}
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
		return count;
	}

	@Override
	public int executeUpdate(java.util.List<? extends org.molgenis.omx.auth.MolgenisPermission> entities) throws org.molgenis.framework.db.DatabaseException
	{
		int count = 0;

		try
		{
			for (org.molgenis.omx.auth.MolgenisPermission molgenisPermission : entities) 
			{
				edit(molgenisPermission);
				++count;
			} 
			return count;
		}
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }		
	}

	@Override
	public int executeRemove(java.util.List<? extends org.molgenis.omx.auth.MolgenisPermission> entities) throws org.molgenis.framework.db.DatabaseException
	{
		int count = 0;		
		try 
		{
			for (org.molgenis.omx.auth.MolgenisPermission molgenisPermission : entities) 
			{
				destroy(molgenisPermission);
				++count;
			}
		} 
		catch (Exception ex) 
		{
            throw new org.molgenis.framework.db.DatabaseException(ex);
        }
		return count;
	}
	
	@Override
	public String getTableFieldName(String fieldName)
	{
		if("id".equalsIgnoreCase(fieldName)) return "id";
		if("MolgenisPermission_id".equalsIgnoreCase(fieldName)) return "id";
		if("Identifier".equalsIgnoreCase(fieldName)) return "Identifier";
		if("MolgenisPermission_Identifier".equalsIgnoreCase(fieldName)) return "Identifier";
		if("Name".equalsIgnoreCase(fieldName)) return "Name";
		if("MolgenisPermission_Name".equalsIgnoreCase(fieldName)) return "Name";
		if("role_".equalsIgnoreCase(fieldName)) return "role_";
		if("MolgenisPermission_role_".equalsIgnoreCase(fieldName)) return "role_";
		if("entity".equalsIgnoreCase(fieldName)) return "entity";
		if("MolgenisPermission_entity".equalsIgnoreCase(fieldName)) return "entity";
		if("permission".equalsIgnoreCase(fieldName)) return "permission";
		if("MolgenisPermission_permission".equalsIgnoreCase(fieldName)) return "permission";
		if("role__id".equalsIgnoreCase(fieldName)) return "role_";
		if("MolgenisPermission_role__id".equalsIgnoreCase(fieldName)) return "role_";
		if("role__Name".equalsIgnoreCase(fieldName)) return "role_.Name";	
		if("MolgenisPermission_role__Name".equalsIgnoreCase(fieldName)) return "role_.Name";
		if("entity_id".equalsIgnoreCase(fieldName)) return "entity";
		if("MolgenisPermission_entity_id".equalsIgnoreCase(fieldName)) return "entity";
		if("entity_ClassName".equalsIgnoreCase(fieldName)) return "entity.className";	
		if("MolgenisPermission_entity_ClassName".equalsIgnoreCase(fieldName)) return "entity.className";
		return fieldName;
	}
	
	/**
	 * Return EMPTY list of given allocated size
	 *
	 * @param i initial capacity of returned EMPTY list
	 * @return an EMPTY list with initial capacity given by size
	 */
	@Override
	public java.util.List<org.molgenis.omx.auth.MolgenisPermission> createList(int size)
	{
		return new java.util.ArrayList<org.molgenis.omx.auth.MolgenisPermission>(size);
	}			

	@Override
	public org.molgenis.omx.auth.MolgenisPermission create()
	{
		return new org.molgenis.omx.auth.MolgenisPermission();
	}

	@Override
	//Resolve
	public void resolveForeignKeys(java.util.List<org.molgenis.omx.auth.MolgenisPermission> entities)  throws org.molgenis.framework.db.DatabaseException, java.text.ParseException
	{
		//create foreign key map for field 'role_' to molgenisRole.id using Name)	
		//we will use a hash of the values to ensure that entities are only queried once	
		final java.util.Map<String, org.molgenis.framework.db.QueryRule> role_Rules = new java.util.LinkedHashMap<String, org.molgenis.framework.db.QueryRule>();
		//create foreign key map for field 'entity' to molgenisEntity.id using className)	
		//we will use a hash of the values to ensure that entities are only queried once	
		final java.util.Map<String, org.molgenis.framework.db.QueryRule> entityRules = new java.util.LinkedHashMap<String, org.molgenis.framework.db.QueryRule>();
		//create all query rules	
		for(org.molgenis.omx.auth.MolgenisPermission object: entities)
		{
			//create xref/mref rule filtering MolgenisRole on the label Name
			if(object.getRole_Id() == null && object.getRole_Name() != null)
			{
				Object label = object.getRole_Name();
				{
					org.molgenis.framework.db.QueryRule xrefFilter = new org.molgenis.framework.db.QueryRule("Name", org.molgenis.framework.db.QueryRule.Operator.EQUALS, label.toString());
					
					if(label != null && !role_Rules.containsKey(label))
					{
						role_Rules.put(""+label, xrefFilter);
						role_Rules.put(""+label+"_OR_", new org.molgenis.framework.db.QueryRule(org.molgenis.framework.db.QueryRule.Operator.OR));
					}
				}
			}		
			//create xref/mref rule filtering MolgenisEntity on the label className
			if(object.getEntity_Id() == null && object.getEntity_ClassName() != null)
			{
				Object label = object.getEntity_ClassName();
				{
					org.molgenis.framework.db.QueryRule xrefFilter = new org.molgenis.framework.db.QueryRule("className", org.molgenis.framework.db.QueryRule.Operator.EQUALS, label.toString());
					
					if(label != null && !entityRules.containsKey(label))
					{
						entityRules.put(""+label, xrefFilter);
						entityRules.put(""+label+"_OR_", new org.molgenis.framework.db.QueryRule(org.molgenis.framework.db.QueryRule.Operator.OR));
					}
				}
			}		
		}

		//resolve foreign key field 'role_' to molgenisRole.id using Name)
		final java.util.Map<String,Integer> role__Labels_to_IdMap = new java.util.TreeMap<String,Integer>();
		if(role_Rules.size() > 0)
		{		
		
			java.util.List<org.molgenis.omx.auth.MolgenisRole> role_List = null;
			try
			{
				role_List = getDatabase().find(org.molgenis.omx.auth.MolgenisRole.class, role_Rules.values().toArray(new org.molgenis.framework.db.QueryRule[role_Rules.values().size()]));
			}
			catch(Exception e)
			{
				// something went wrong while querying for this entities' name field
				// we assume it has no such field, which should have been checked earlier ofcourse
				// regardless, just quit the function now
				throw new org.molgenis.framework.db.DatabaseException(e);
			}
		
			for(org.molgenis.omx.auth.MolgenisRole xref :  role_List)
			{
				String key = "";
				key += 	xref.getName();
				
				role__Labels_to_IdMap.put(key, xref.getId());
			}
		}
		//resolve foreign key field 'entity' to molgenisEntity.id using className)
		final java.util.Map<String,Integer> entity_Labels_to_IdMap = new java.util.TreeMap<String,Integer>();
		if(entityRules.size() > 0)
		{		
		
			java.util.List<org.molgenis.omx.core.MolgenisEntity> entityList = null;
			try
			{
				entityList = getDatabase().find(org.molgenis.omx.core.MolgenisEntity.class, entityRules.values().toArray(new org.molgenis.framework.db.QueryRule[entityRules.values().size()]));
			}
			catch(Exception e)
			{
				// something went wrong while querying for this entities' name field
				// we assume it has no such field, which should have been checked earlier ofcourse
				// regardless, just quit the function now
				throw new org.molgenis.framework.db.DatabaseException(e);
			}
		
			for(org.molgenis.omx.core.MolgenisEntity xref :  entityList)
			{
				String key = "";
				key += 	xref.getClassName();
				
				entity_Labels_to_IdMap.put(key, xref.getId());
			}
		}

		//update objects with the keys
		for(int i = 0; i < entities.size(); i++)
		{
			org.molgenis.omx.auth.MolgenisPermission object = entities.get(i);		
			//update object using label fields Name
			if(object.getRole_Id() == null )
			{
					String key = "";
					if(object.getRole_Name() != null)
						key += 	object.getRole_Name();
					
					if(!"".equals(key) && role__Labels_to_IdMap.get(key) == null) 
					{
						throw new org.molgenis.framework.db.DatabaseException("role__Name cannot be resolved: unknown xref='"+key+"'");
					}
					else
					{
						object.setRole_Id(role__Labels_to_IdMap.get(key));
					}
			}
			//update object using label fields className
			if(object.getEntity_Id() == null )
			{
					String key = "";
					if(object.getEntity_ClassName() != null)
						key += 	object.getEntity_ClassName();
					
					if(!"".equals(key) && entity_Labels_to_IdMap.get(key) == null) 
					{
						throw new org.molgenis.framework.db.DatabaseException("entity_className cannot be resolved: unknown xref='"+key+"'");
					}
					else
					{
						object.setEntity_Id(entity_Labels_to_IdMap.get(key));
					}
			}
						
		}
	}	
	
	@Override
	public org.molgenis.fieldtypes.FieldType getFieldType(String fieldName)
	{
			if("id".equalsIgnoreCase(fieldName) || "molgenisPermission.id".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.IntField();
			if("identifier".equalsIgnoreCase(fieldName) || "molgenisPermission.identifier".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.StringField();
			if("name".equalsIgnoreCase(fieldName) || "molgenisPermission.name".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.StringField();
			if("role_".equalsIgnoreCase(fieldName) || "molgenisPermission.role_".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.XrefField();
			if("entity".equalsIgnoreCase(fieldName) || "molgenisPermission.entity".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.XrefField();
			if("permission".equalsIgnoreCase(fieldName) || "molgenisPermission.permission".equalsIgnoreCase(fieldName)) 
				return new org.molgenis.fieldtypes.EnumField();
		return null;
	}		
	@Override
	public void prepareFileAttachements(java.util.List<org.molgenis.omx.auth.MolgenisPermission> entities, java.io.File baseDir) throws java.io.IOException
	{
	}

	@Override
	public boolean saveFileAttachements(java.util.List<org.molgenis.omx.auth.MolgenisPermission> entities, java.io.File baseDir) throws java.io.IOException
	{
		return false;
	}}
